#!/usr/bin/perl
# qmail ALIAS creation script for CML-3.2-991102-snap
# Written by OKADA Tetsutaro <tetsuta@ec.kagawa-u.ac.jp>
# Feb. 5, 2000

$mlname = $ARGV[0];
$admin = $ARGV[1];
$answer = "";
$nobody = "";

if ($mlname =~ /\@/ || $admin =~ /\@/) {
    print "You have to exclude '\@domain.name'\n";
    $mlname = "";
    $admin = "";
}

until ($answer =~ /[yY]/ || $answer =~ /[yY][eE][sS]/) {
    while ($mlname eq "") {
	print "Enter your ML name: ";
	chomp($mlname = <STDIN>);
	if ($mlname =~ /\@/) {
	    print "You have to exclude '\@domain.name'\n";
	    $mlname = "";
	}
    }
    while ($admin eq "") {
	print "Enter ML administrator's login name: ";
	chomp($admin = <STDIN>);
	if ($admin =~ /\@/) {
	    print "You have to exclude '\@domain.name'\n";
	    $admin = "";
	}
    }
    print "Enter qmail alias directly [/var/qmail/alias]: ";
    chomp($qmaildir = <STDIN>);
    if ($qmaildir eq "") {
	$qmaildir = "/var/qmail/alias";
    }
    print "\nML name is '$mlname'.\n";
    print "ML admin is '$admin'.\n";
    print "qmail alias directly is '$qmaildir'.\n\n";
    print "Are they correct? [y/N]: ";
    chomp($answer = <STDIN>);
    unless ($answer =~ /[yY]/ || $answer =~ /[yY][eE][sS]/) {
	$mlname = "";
	$admin = "";
    }
}

print "\nInstalling alias files...\n\n";

open(MLADMIN, ">${qmaildir}/.qmail-${mlname}-request") || die "$!";
print MLADMIN "${admin}\n";
print "Created ${qmaildir}/.qmail-${mlname}-request\n";
close(MLADMIN);

open(ML, ">${qmaildir}/.qmail-${mlname}") || die "$!";
print ML "${admin}-${mlname}\n";
print "Created ${qmaildir}/.qmail-${mlname}\n";
close(ML);

open(MLCONTROL, ">${qmaildir}/.qmail-${mlname}-control") || die "$!";
print MLCONTROL "${admin}-${mlname}-control\n";
print "Created ${qmaildir}/.qmail-${mlname}-control\n";
close(MLCONTROL);

open(MLDIST, ">${qmaildir}/.qmail-${mlname}-dist") || die "$!";
print MLDIST "${admin}-${mlname}-dist\n";
print "Created ${qmaildir}/.qmail-${mlname}-dist\n";
close(MLDIST);

open(MLDIGEST, ">${qmaildir}/.qmail-${mlname}-digest-dist") || die "$!";
print MLDIGEST "${admin}-${mlname}-digest-dist\n";
print "Created ${qmaildir}/.qmail-${mlname}-digest-dist\n";
close(MLDIGEST);

chmod(0644, "${qmaildir}/.qmail-${mlname}-request", "${qmaildir}/.qmail-${mlname}", "${qmaildir}/.qmail-${mlname}-control", "${qmaildir}/.qmail-${mlname}-dist", "${qmaildir}/.qmail-${mlname}-digest-dist")  || die "$!" ;

print "\nChecking '.qmail-nobody' alias...\n";

unless (-e "${qmaildir}/.qmail-nobody") {
    print "\nThere isn't '.qmail-nobody'.\n";
    &nobody_alias;
} else {
    open(NOBALIAS, "${qmaildir}/.qmail-nobody") || die "$!";
    while (<NOBALIAS>) {
	$line = $line + 1;
	unless (/^[ \t]*#/) {
		print "line${line}: Bad settings...\n";
		print "\nIt doesn't seem to dump a mail for 'nobody'.\n";
		&nobody_alias;
		last;
	    } 
	print "line${line}: Good.\n";
    }
}

print "\ndone.\n\n";

print "You have to restart 'qmail-send'.\n";
print "kill -HUP 'qmail-send pid'.\n\n";


sub nobody_alias {
    while ($nobody eq "") {
	print "Set to dump a mail for 'nobody' into null? [y/n]: ";
	chomp($nobody = <STDIN>);
	if ($nobody =~ /[yY]/ || $nobody =~ /[yY][eE][sS]/) {
	    open(NOBODY, ">${qmaildir}/.qmail-nobody") || die "$!";
	    print NOBODY "## This file is setting to dump a mail for 'nobody' into null.\n";
	    print NOBODY "#  You have to keep the comment lines only in this file.\n";
	    print NOBODY "#  This file was created by alias-root.pl script in CML package.\n";
	    print NOBODY "#  If you would like to know more details,\n";
	    print NOBODY "#        please see 'nobody_alias' file in the source package.\n";
	    print "\nCreated ${qmaildir}/.qmail-nobody\n";
	    close(NOBODY);
	} elsif ($nobody =~ /[nN]/ || $nobody =~ /[nN][oO]/) {
	    print "\nHmm..., I didn't install '.qmail-nobody' !\n";
	    print "I recommend setting 'nobody' alias to '#' yourself.\n";
	    print "Please see 'nobody_alias' instruction in the source package.\n";
	} else {
	    $nobody = "";
	}
    }
}
