#!/usr/bin/perl
# qmail USER alias creation script for CML-3.2-991102-snap
# Written by OKADA Tetsutaro <tetsuta@ec.kagawa-u.ac.jp>
# Feb. 5, 2000

chdir;

$mlname = $ARGV[0];
$answer = "";
$cmldir = "";

if ($mlname =~ /\@/) {
    print "You have to exclude '\@domain.name'\n";
    $mlname = "";
}

until ($answer =~ /[yY]/ || $answer =~ /[yY][eE][sS]/) {
    while ($mlname eq "") {
	print "Enter your ML name: ";
	chomp($mlname = <STDIN>);
	if ($mlname =~ /\@/) {
	    print "You have to exclude '\@domain.name'\n";
	    $mlname = "";
	}
    }
    while ($cmldir eq "") {
	print "Enter cml directly [/usr/local/etc/cml]: ";
	chomp($cmldir = <STDIN>);
	if ($cmldir eq "") {
	    $cmldir = "/usr/local/etc/cml";
	}
#
	unless (-x "${cmldir}/cmld") {
	    print "$cmldir isn't correct CML directory.\n";
	    $cmldir = "";
	}
    }
    print "\nML name is '$mlname'.\n";
    print "CML directly is '$cmldir'.\n\n";
    print "Are they correct? [y/N]";
    chomp($answer = <STDIN>);
    unless ($answer =~ /[yY]/ || $answer =~ /[yY][eE][sS]/) {
	$mlname = "";
	$cmldir = "";
    }
}

print "\nInstalling alias files...\n\n";

open(ML, ">.qmail-${mlname}") || die "$!";
print ML "|${cmldir}/cmld ${mlname}\n";
print "Created ~/.qmail-${mlname}\n";
close(ML);

open(MLCONTROL, ">.qmail-${mlname}-control") || die "$!";
print MLCONTROL "|${cmldir}/cmas ${mlname}\n";
print "Created ~/.qmail-${mlname}-control\n";
close(MLCONTROL);

if (-l ".qmail-${mlname}-dist") {
    unlink(".qmail-${mlname}-dist") || die "$!";
}
symlink("${cmldir}/${mlname}/${mlname}-list", ".qmail-${mlname}-dist") || die "$!";
print "Created ~/.qmail-${mlname}-dist\n";

if (-l ".qmail-${mlname}-digest-dist") {
    unlink(".qmail-${mlname}-digest-dist") || die "$!";
}
symlink("${cmldir}/${mlname}/${mlname}-digest", ".qmail-${mlname}-digest-dist") || die "$!";
print "Created ~/.qmail-${mlname}-digest-dist\n";

chmod(0644, ".qmail-${mlname}", ".qmail-${mlname}-control")  || die "$!" ;

print "\ndone.\n";
